#
# This files contains definitions needed to use CGAL in a program.
# DO NOT EDIT THIS. The definitons have been generated by CMake at configuration time.
# This file is loaded by cmake via the command "find_package(CGAL)"
#
# This file correspond to a possibly out-of-sources CGAL configuration, thus the actual location
# must be given by the cmake variable or enviroment variable CGAL_DIR. 

set(CGAL_CONFIG_LOADED TRUE)

get_filename_component(CGAL_CONFIG_DIR "${CMAKE_CURRENT_LIST_FILE}" PATH)

# The else condition of this code is intentionally not present in
# CGALConfig_install.cmake.in since it cannot happen there.
# Note also that for CMake<=2.8.11 (detected by the absence of CMP0024),
# the else() condition is never used.
if(NOT POLICY CMP0024 OR NOT CGAL_BUILDING_LIBS)
  include("${CGAL_CONFIG_DIR}/CGALExports.cmake")

  macro(CGAL_get_property_optional VAR TARGET PROPERTY)
    if(TARGET ${TARGET})
      get_property(${VAR} TARGET ${TARGET} PROPERTY ${PROPERTY})
    else()
      set(${VAR} "")
    endif()
  endmacro()

  if(NOT MSVC)
    CGAL_get_property_optional(CGAL_LIBRARY CGAL::CGAL LOCATION)
    CGAL_get_property_optional(CGAL_Core_LIBRARY CGAL::CGAL_Core LOCATION)
    CGAL_get_property_optional(CGAL_ImageIO_LIBRARY CGAL::CGAL_ImageIO LOCATION)
    CGAL_get_property_optional(CGAL_Qt3_LIBRARY CGAL::CGAL_Qt3 LOCATION)
    CGAL_get_property_optional(CGAL_Qt5_LIBRARY CGAL::CGAL_Qt5 LOCATION)
  else()
    set(CGAL_LIBRARY         "")
    set(CGAL_Core_LIBRARY    "")
    set(CGAL_ImageIO_LIBRARY "")
    set(CGAL_Qt3_LIBRARY     "")
    set(CGAL_Qt5_LIBRARY     "")
  endif()
else()
  # We are currently in a CGAL Build and CGALExports.cmake has not
  # necessarily been created yet. Just alias the targets. Also don't
  # access the LOCATION property here to set lib_LIBRARY, since those
  # targets are not imported and this is disallowed by CMP0026. Just
  # set it to the target name.
  macro(CGAL_alias_library lib)
    if(TARGET ${lib} AND NOT TARGET CGAL::${lib})
      add_library(CGAL::${lib} ALIAS ${lib})
      set(${lib}_LIBRARY CGAL::${lib})
    else()
      set(${lib}_LIBRARY "")
    endif()
  endmacro()

  CGAL_alias_library(CGAL)
  CGAL_alias_library(CGAL_Core)
  CGAL_alias_library(CGAL_ImageIO)
  CGAL_alias_library(CGAL_Qt3)
  CGAL_alias_library(CGAL_Qt5)
endif()

set(CGAL_INSTALLATION_PACKAGE_DIR "/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Installation")
set(CGAL_CORE_PACKAGE_DIR "/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Core")

set(CGAL_MAJOR_VERSION    "4" )
set(CGAL_MINOR_VERSION    "7" )
set(CGAL_BUILD_VERSION    "900" )
set(CGAL_SCM_BRANCH_NAME  "HEAD")
set(CGAL_GIT_SHA1         "")

set(CGAL_BUILD_SHARED_LIBS        "ON" )
set(CGAL_Boost_USE_STATIC_LIBS    "OFF" )

set(CGAL_CXX_FLAGS_INIT                   " -frounding-math" )
set(CGAL_CXX_FLAGS_RELEASE_INIT           "-O3 -DNDEBUG" )
set(CGAL_CXX_FLAGS_DEBUG_INIT             "-g" )
set(CGAL_MODULE_LINKER_FLAGS_INIT         "" )
set(CGAL_MODULE_LINKER_FLAGS_RELEASE_INIT "" )
set(CGAL_MODULE_LINKER_FLAGS_DEBUG_INIT   "" )
set(CGAL_SHARED_LINKER_FLAGS_INIT         "" )
set(CGAL_SHARED_LINKER_FLAGS_RELEASE_INIT "" )
set(CGAL_SHARED_LINKER_FLAGS_DEBUG_INIT   "" )
set(CGAL_BUILD_TYPE_INIT                  "Release" )

set(CGAL_INCLUDE_DIRS      "/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/buildR/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Barycentric_coordinates_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Maintenance/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Hash_map/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Surface_mesher/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Testsuite/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Kernel_23/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/wininst/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/AABB_tree/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Intersections_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Boolean_set_operations_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Distance_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Spatial_searching/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Operations_on_polyhedra/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Solver_interface/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Installation/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Distance_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Stream_lines_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/CGAL_ipelets/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Periodic_3_triangulation_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Subdivision_method_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Mesh_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Scale_space_reconstruction_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/QP_solver/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Qt_widget/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Scripts/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Polygon/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Arithmetic_kernel/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Cartesian_kernel/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/NewKernel_d/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/HalfedgeDS/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Envelope_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Surface_mesh_shortest_path/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Triangulation/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Mesh_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Surface_modeling/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Polynomial/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Principal_component_analysis/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Visibility_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/CGAL_Core/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Nef_S2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Point_set_shape_detection_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Algebraic_kernel_for_spheres/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Triangulation_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Convex_decomposition_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Algebraic_kernel_for_circles/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Voronoi_diagram_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Jet_fitting_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Arrangement_on_surface_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Surface_mesh_parameterization/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Union_find/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Surface_mesh/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Modifier/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Periodic_2_triangulation_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Filtered_kernel/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Stream_support/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/GraphicsView/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Homogeneous_kernel/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Snap_rounding_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Ridges_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Interpolation/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Alpha_shapes_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/CGAL_ImageIO/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Interval_skip_list/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Minkowski_sum_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Surface_mesh_segmentation/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Straight_skeleton_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Convex_hull_d/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Surface_mesh_skeletonization/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Number_types/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Profiling_tools/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Polygon_mesh_processing/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Minkowski_sum_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Nef_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Polyhedron/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Circular_kernel_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/SearchStructures/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/MacOSX/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Partition_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Inventor/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Combinatorial_map/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/BGL/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Alpha_shapes_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Interval_support/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Surface_mesh_simplification/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Convex_hull_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Modular_arithmetic/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Linear_cell_complex/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Point_set_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Circular_kernel_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Skin_surface_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Kernel_d/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Advancing_front_surface_reconstruction/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Intersections_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Bounding_volumes/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Polyline_simplification_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Polytope_distance_d/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Apollonius_graph_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Segment_Delaunay_graph_Linf_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Conic_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Circulator/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Generator/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Algebraic_kernel_d/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/STL_Extension/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Geomview/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Envelope_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Surface_reconstruction_points_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Polyhedron_IO/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Point_set_processing_3/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Kinetic_data_structures/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Nef_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Segment_Delaunay_graph_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Triangulation_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/LEDA/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Optimisation_basic/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/OpenNL/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Convex_hull_2/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Random_numbers/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Matrix_search/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Algebraic_foundations/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Spatial_sorting/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Inscribed_areas/include;/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Box_intersection_d/include" )
set(CGAL_MODULES_DIR       "/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/Installation/cmake/modules" )
set(CGAL_LIBRARIES_DIR     "/home/travis/build/mtola/MEPP2/cgal-releases-CGAL-4.7/buildR/lib" )

set(WITH_CGAL         "ON" )
set(WITH_CGAL_Core    "ON" )
set(WITH_CGAL_ImageIO "ON" )
set(WITH_CGAL_Qt3     "OFF" )
set(WITH_CGAL_Qt5     "ON" )

set(CGAL_3RD_PARTY_INCLUDE_DIRS   "/usr/include" )
set(CGAL_3RD_PARTY_DEFINITIONS    "" )
set(CGAL_3RD_PARTY_LIBRARIES_DIRS "/usr/lib/x86_64-linux-gnu" )
set(CGAL_3RD_PARTY_LIBRARIES      "/usr/lib/x86_64-linux-gnu/libboost_thread.so;/usr/lib/x86_64-linux-gnu/libboost_system.so;/usr/lib/x86_64-linux-gnu/libpthread.so" )

set(CGAL_Core_3RD_PARTY_INCLUDE_DIRS   "" )
set(CGAL_Core_3RD_PARTY_DEFINITIONS    "" )
set(CGAL_Core_3RD_PARTY_LIBRARIES_DIRS "" )
set(CGAL_Core_3RD_PARTY_LIBRARIES      "" )

set(CGAL_ImageIO_3RD_PARTY_INCLUDE_DIRS   "/usr/include;/usr/include" )
set(CGAL_ImageIO_3RD_PARTY_DEFINITIONS    "-DCGAL_USE_ZLIB" )
set(CGAL_ImageIO_3RD_PARTY_LIBRARIES_DIRS "" )
set(CGAL_ImageIO_3RD_PARTY_LIBRARIES      "/usr/lib/x86_64-linux-gnu/libGLU.so;/usr/lib/x86_64-linux-gnu/libGL.so;/usr/lib/x86_64-linux-gnu/libz.so" )
set(CGAL_ImageIO_USE_ZLIB                 "ON" )

set(CGAL_Qt3_3RD_PARTY_INCLUDE_DIRS   "" )
set(CGAL_Qt3_3RD_PARTY_DEFINITIONS    "" )
set(CGAL_Qt3_3RD_PARTY_LIBRARIES_DIRS "" )
set(CGAL_Qt3_3RD_PARTY_LIBRARIES      "" )

set(CGAL_Qt5_3RD_PARTY_INCLUDE_DIRS   "" )
set(CGAL_Qt5_3RD_PARTY_DEFINITIONS    "" )
set(CGAL_Qt5_3RD_PARTY_LIBRARIES_DIRS "" )
set(CGAL_Qt5_3RD_PARTY_LIBRARIES      "" )

set(CGAL_VERSION "${CGAL_MAJOR_VERSION}.${CGAL_MINOR_VERSION}.${CGAL_BUILD_VERSION}")

set(CGAL_USE_FILE "${CGAL_MODULES_DIR}/UseCGAL.cmake" )

set(CGAL_ALLOW_ALL_PRECONFIGURED_LIBS_COMPONENT "OFF")

if ( CGAL_FIND_REQUIRED )
  set( CHECK_CGAL_COMPONENT_MSG_ON_ERROR TRUE        )
  set( CHECK_CGAL_COMPONENT_ERROR_TYPE   FATAL_ERROR )
  set( CHECK_CGAL_COMPONENT_ERROR_TITLE  "ERROR:"    )
else()
  if ( NOT CGAL_FIND_QUIETLY )
    set( CHECK_CGAL_COMPONENT_MSG_ON_ERROR TRUE      )
    set( CHECK_CGAL_COMPONENT_ERROR_TYPE   STATUS    )
    set( CHECK_CGAL_COMPONENT_ERROR_TITLE "NOTICE:" )
  else()  
    set( CHECK_CGAL_COMPONENT_MSG_ON_ERROR FALSE )
  endif()
endif()

set(CGAL_CONFIGURED_LIBRARIES "CGAL_Core;CGAL_ImageIO;CGAL_Qt3;CGAL_Qt5")

macro(check_cgal_component COMPONENT)

  set( CGAL_LIB ${COMPONENT} )
  #message("LIB: ${CGAL_LIB}")

  if ( "${CGAL_LIB}" STREQUAL "CGAL" )
    set( CGAL_FOUND TRUE )
    set( CHECK_CGAL_ERROR_TAIL "" )
  else() 
    if ( WITH_${CGAL_LIB} )
      if(TARGET CGAL::${CGAL_LIB})
        set( ${CGAL_LIB}_FOUND TRUE )
      else()
        set( ${CGAL_LIB}_FOUND FALSE )
        set( CHECK_${CGAL_LIB}_ERROR_TAIL " CGAL was configured with WITH_${CGAL_LIB}=ON, but one of the dependencies of ${CGAL_LIB} was not configured properly." )
      endif()
    else()
      set( ${CGAL_LIB}_FOUND FALSE )
      set( CHECK_${CGAL_LIB}_ERROR_TAIL " Please configure CGAL using WITH_${CGAL_LIB}=ON." )
    endif()
  endif()  

  if ( NOT ${CGAL_LIB}_FOUND AND CHECK_CGAL_COMPONENT_MSG_ON_ERROR )
    message( ${CHECK_CGAL_COMPONENT_ERROR_TYPE} "${CHECK_CGAL_COMPONENT_ERROR_TITLE} The ${CGAL_LIB} library was not configured.${CHECK_${CGAL_LIB}_ERROR_TAIL}" )
  endif()
  
endmacro()

check_cgal_component("CGAL")

foreach( CGAL_COMPONENT ${CGAL_FIND_COMPONENTS} )
  list (FIND CGAL_CONFIGURED_LIBRARIES "CGAL_${CGAL_COMPONENT}" POSITION)
  if ("${POSITION}" STRGREATER "-1") # means: CGAL_COMPONENT is contained in list
    check_cgal_component("CGAL_${CGAL_COMPONENT}")
# TODO EBEB do something for supporting lib in check_component?
  endif()
endforeach()

# Starting with cmake 2.6.3, CGAL_FIND_COMPONENTS is cleared out when find_package returns.
# But we need it within UseCGAL.cmake, so we save it aside into another variable
set( CGAL_REQUESTED_COMPONENTS ${CGAL_FIND_COMPONENTS} )

# for preconfigured libs
set(CGAL_ENABLE_PRECONFIG "ON")
set(CGAL_SUPPORTING_3RD_PARTY_LIBRARIES "GMP;GMPXX;MPFR;ZLIB;OpenGL;LEDA;MPFI;RS;RS3;OpenNL;Eigen3;BLAS;LAPACK;QGLViewer;ESBTL;Coin3D;NTL;IPE")
set(CGAL_ESSENTIAL_3RD_PARTY_LIBRARIES "GMP;MPFR")

set(CGAL_DISABLE_GMP "")
set(CGAL_EXT_LIB_Qt5_PREFIX "QT")
set(CGAL_EXT_LIB_Eigen3_PREFIX "EIGEN3")
set(CGAL_EXT_LIB_QGLViewer_PREFIX "QGLVIEWER")
set(CGAL_EXT_LIB_Coin3D_PREFIX "COIN3D")

if (NOT CGAL_IGNORE_PRECONFIGURED_GMP)
  set( GMP_FOUND           "TRUE" )
  set( GMP_USE_FILE        "" )
  set( GMP_INCLUDE_DIR     "/usr/include/x86_64-linux-gnu" )
  set( GMP_LIBRARIES       "/usr/lib/x86_64-linux-gnu/libgmp.so" )
  set( GMP_DEFINITIONS     "" )
endif()

if (NOT CGAL_IGNORE_PRECONFIGURED_MPFR)
  set( MPFR_FOUND           "TRUE" )
  set( MPFR_USE_FILE        "" )
  set( MPFR_INCLUDE_DIR     "/usr/include" )
  set( MPFR_LIBRARIES       "/usr/lib/x86_64-linux-gnu/libmpfr.so" )
  set( MPFR_DEFINITIONS     "" )
endif()

